/*	ccfont.h -- ljsdcdev
	libcrabclaw Font stuff
	libcrabclaw
	Copyright (C) 2004 Lawrence Sebald	*/

#include "cctypes.h"
#include <GL/gl.h>

#ifndef __CCFONT_H
#define __CCFONT_H

#ifdef __cplusplus
extern "C"	{
#endif

#define CC_FONT_TTF 0

typedef struct	{
	int h;
	int w;
	float u;
	float v;
	float below;
	float adv;
} cc_glyph_t;

typedef struct	{
	GLuint * tex;
	cc_glyph_t * gdat;
	GLfloat h;
	/* Other stuff may be added in the future */
} cc_font_t;

void cc_font_init();
void cc_font_deinit();
int cc_font_load(const char * fn, cc_font_t * font, int type, float h);
void cc_font_destroy(cc_font_t * font);
void cc_print(cc_font_t * font, float x, float y, float he, const char * str);
void cc_printf(cc_font_t * font, float x, float y, float he, const char * fmt, ...);
void cc_fcolored_printf(cc_font_t * font, float x, float y, float he,
                        float a, float r, float g, float b, const char * fmt, ...);
void cc_icolored_printf(cc_font_t * font, float x, float y, float he,
                        uint8 a, uint8 r, uint8 g, uint8 b, const char * fmt, ...);

#ifdef __cplusplus
}
#endif

#endif
