/*	cctimer.c -- ljsdcdev
	libcrabclaw timing functions
	libcrabclaw
	Copyright (C) 2004 Lawrence Sebald	*/

#include <sys/timeb.h>
#include <unistd.h>
#include "cctimer.h"

static uint64 __start;

void cc_timer_init()	{
	struct timeb tb;
	ftime(&tb);
	__start = tb.time * 1000 + tb.millitm;
}

uint64 cc_timer_get_ticks()	{
	struct timeb tb;
	ftime(&tb);
	return (tb.time * 1000 + tb.millitm) - __start;
}

uint64 cc_timer_create()	{
	struct timeb tb;
	ftime(&tb);

	return (tb.time * 1000 + tb.millitm);
}

uint64 cc_timer_elapsed(uint64 timer)	{
	struct timeb tb;
	ftime(&tb);

	return (tb.time * 1000 + tb.millitm) - timer;
}

#if 0
void cc_timer_sleep(uint64 ms)	{
	struct timeb tb, _tb;
	ftime(&tb);

	while((tb.time * 1000 + tb.millitm + ms) < (_tb.time * 1000 + _tb.millitm));
}
#endif
void cc_timer_sleep(uint64 ms)	{
	usleep(ms);
}
